#include <iostream>
#include <verilated.h>
#include "Vadd.h"

Vadd *g_top;
vluint64_t g_main_time = 0; //current simulation time

//called by $time in Verilog
double sc_time_stamp()
{
    return g_main_time;// converts to double, to match what SystemC does
}

int main(int argc, char *argv[])
{    
    Verilated::commandArgs(argc, argv);//remember args
    g_top = new Vadd;//create instance

    //set some inputs
    //g_top->reset_l = 0;

    //simulate until $finish
    while(!Verilated::gotFinish())
    {
        std::cout << "enter a: "; std::cin >> g_top->a;
        std::cout << "enter b: "; std::cin >> g_top->b;
        //if(g_main_time > 10)
        //    g_top->reset_l = 1; //deassert reset
        //if((g_main_time % 10) == 1)
        //    g_top->clk = 1; //toggle clock
        //if((g_main_time % 10) == 6)
        //    g_top->clk = 0;
        g_top->eval(); //evaluate model
        std::cout << "sum: " << g_top->sum << std::endl; //eead output
        g_main_time++; //increment time
    }
    //model cleanup
    g_top->final();
    delete g_top;
    //
    return 0;
}
